Attribute VB_Name = "Engine"
Option Explicit
Public Xf As Integer, Yf As Integer
Public Rotates As Coord

Public Sub StartCamaraMove()
    Dim Ay As Integer
    Camara.Timer = Camara.Speed
    Camara.AddO.x = (Camara.Origin.x - Camara.TargetO.x) / Camara.Speed
    Camara.AddO.y = (Camara.Origin.y - Camara.TargetO.y) / Camara.Speed
    Camara.AddO.z = (Camara.Origin.z - Camara.TargetO.z) / Camara.Speed
    If Camara.Angle.y > 360 Then Camara.Angle.y = Camara.Angle.y - 360
    If Camara.Angle.y < 0 Then Camara.Angle.y = Camara.Angle.y + 360
    Ay = (Camara.Angle.y - Camara.TargetA.y) / Camara.Speed
    If Camara.TargetA.y > Camara.Angle.y + 180 Then Ay = (Camara.Angle.y + (360 - Camara.TargetA.y)) / Camara.Speed
    If Camara.TargetA.y + 180 < Camara.Angle.y Then Ay = -(Camara.TargetA.y + (360 - Camara.Angle.y)) / Camara.Speed
    Camara.AddA.x = (Camara.Angle.x - Camara.TargetA.x) / Camara.Speed
    Camara.AddA.y = Ay
    Camara.AddA.z = (Camara.Angle.z - Camara.TargetA.z) / Camara.Speed
End Sub

Public Sub RunEngine()
    Dim Unit As Integer
    If Camara.Timer > 0 Then
        Camara.Timer = Camara.Timer - 1
        Camara.Origin.x = Camara.Origin.x - Camara.AddO.x
        Camara.Origin.y = Camara.Origin.y - Camara.AddO.y
        Camara.Origin.z = Camara.Origin.z - Camara.AddO.z
        Camara.Angle.x = Camara.Angle.x - Camara.AddA.x
        Camara.Angle.y = Camara.Angle.y - Camara.AddA.y
        Camara.Angle.z = Camara.Angle.z - Camara.AddA.z
        If Camara.Angle.x > 360 Then Camara.Angle.x = Camara.Angle.x - 360
        If Camara.Angle.y > 360 Then Camara.Angle.y = Camara.Angle.y - 360
        If Camara.Angle.z > 360 Then Camara.Angle.z = Camara.Angle.z - 360
    End If
    Select Case Camara.CamaraMode
        Case 1  'Camara locked onto a specifc point
        Case 2  'Camara focused on an oject at a preset angle
            Camara.TargetO.x = -World(Camara.Object).Origin.x
            Camara.TargetO.z = -World(Camara.Object).Origin.z
            StartCamaraMove
        Case 3 'Camara focused on an object, looking the same way as the object
            Camara.TargetO.x = -World(Camara.Object).Origin.x
            Camara.TargetO.z = -World(Camara.Object).Origin.z
            Camara.TargetA.y = World(Camara.Object).Angle.y
            StartCamaraMove
        Case 4 'Camara focused on an object, looking the same way as the object
            Camara.TargetO.x = -World(Camara.Object).Origin.x
            Camara.TargetO.z = -World(Camara.Object).Origin.z
            Camara.TargetO.y = World(Camara.Object).Origin.y
            Camara.TargetA.x = -World(Camara.Object).Angle.x
            Camara.TargetA.y = World(Camara.Object).Angle.y
            Camara.TargetA.z = -World(Camara.Object).Angle.z
            StartCamaraMove
    End Select
    RotateWorld
    FrmMain.View.Cls
    If Keyboard.Fire = True Then FrmMain.View.Print "Bang!!!"
    For Unit = 1 To WorldCount
        If World(Unit).Used = True Then
            AI Unit
            ModelID = World(Unit).ModelID
            If World(Unit).Rotated.z > -800 Then
                If ModelID = 255 Then
                    DrawDust Unit
                Else
                    Rotate (Unit)
                    DrawObject Unit
                End If
            End If
        End If
    Next Unit
End Sub

Private Sub DrawDust(Unit)
        On Error GoTo BehindCamara
        Dim x As Integer, y As Integer, z As Integer, xx1 As Integer
        Dim yy1 As Integer, xx2 As Integer, yy2 As Integer, xx3 As Integer, yy3 As Integer, n As Byte
        Dim Siz As Integer, Viewhdc
        DustCenter Unit
        x = Rotates.x
        y = Rotates.y
        z = Rotates.z
        Siz = World(Unit).Size
        xx1 = Xf + Int((x + Siz) * (Zeye / (Zeye - z + Siz)))
        yy1 = Yf + Int((y + Siz) * (Zeye / (Zeye - z + Siz)))
        xx2 = Xf + Int((x - Siz) * (Zeye / (Zeye - z - Siz)))
        yy2 = Yf + Int((y - Siz) * (Zeye / (Zeye - z - Siz)))
        xx3 = (xx2 - xx1) - Siz * 0.5
        yy3 = (yy2 - yy1) - Siz * 0.5
        Viewhdc = FrmMain.View.hdc
        
        Select Case World(Unit).UnitID
            Case 255
                ' White, Grey - Smoke
                For n = 1 To 10
                      SetPixel Viewhdc, xx1 + Rnd * xx3, yy1 + Rnd * yy3, vbWhite
                Next n
                For n = 1 To 10
                    SetPixel Viewhdc, xx1 + Rnd * xx3, yy1 + Rnd * yy3, vbBlack
                Next n
            Case 254
                ' Red - Blood
                For n = 1 To 50
                    SetPixel Viewhdc, xx1 + Rnd * xx3, yy1 + Rnd * yy3, vbRed
                Next n
            Case 253
                ' White, Grey - Dirt
                For n = 1 To 5
                    SetPixel Viewhdc, xx1 + Rnd * xx3, yy1 + Rnd * yy3, vbWhite
                Next n
                For n = 1 To 15
                    SetPixel Viewhdc, xx1 + Rnd * xx3, yy1 + Rnd * yy3, vbBlack
                Next n
            Case 252
                ' Yellow, Grey, Red - Fire
                For n = 1 To 20
                    SetPixel Viewhdc, (xx1 + Rnd * xx3), yy1 + (Rnd * yy3), vbBlack
                Next n
                For n = 1 To 20
                    SetPixel Viewhdc, (xx1 + Rnd * xx3), yy1 + (Rnd * yy3), vbYellow
                Next n
                For n = 1 To 20
                    SetPixel Viewhdc, (xx1 + Rnd * xx3), yy1 + (Rnd * yy3), vbRed
                Next n

        End Select
BehindCamara:

End Sub

Private Sub DustCenter(Unit)
        Dim XRotated, YRotated, ZRotated, x, y, z
        Dim WAngle1 As Integer, WAngle2 As Integer, WAngle3 As Integer, Target As Byte
        WAngle1 = Camara.Angle.x Mod 360
        WAngle2 = Camara.Angle.y Mod 360
        WAngle3 = Camara.Angle.z Mod 360
        WAngle2 = 360 - WAngle2
        x = Camara.Origin.x + World(Unit).Origin.x
        y = Camara.Origin.y + World(Unit).Origin.y
        z = -Camara.Origin.z - World(Unit).Origin.z
        XRotated = COSine(WAngle2) * x - SINe(WAngle2) * z
        YRotated = y
        ZRotated = SINe(WAngle2) * x + COSine(WAngle2) * z
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = x
        YRotated = COSine(WAngle1) * y - SINe(WAngle1) * z
        ZRotated = SINe(WAngle1) * y + COSine(WAngle1) * z
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = COSine(WAngle3) * x - SINe(WAngle3) * y
        YRotated = SINe(WAngle3) * x + COSine(WAngle3) * y
        ZRotated = z
        Rotates.x = XRotated
        Rotates.y = YRotated
        Rotates.z = ZRotated
End Sub


Private Sub MorphSkeliton(Unit)
    Dim n As Integer, Target As Byte, Cx As Integer, Cy As Integer, Cz As Integer, sAngle1 As Integer, sAngle2 As Integer, sAngle3 As Integer
    Dim x As Integer, y As Integer, z As Integer
    For n = 1 To Model(ModelID).SkelitonCount
        Target = Model(ModelID).Skeliton(n).Target
        TempMorph(n).Origin.x = Model(ModelID).Skeliton(n).Origin.x
        TempMorph(n).Origin.y = Model(ModelID).Skeliton(n).Origin.y
        TempMorph(n).Origin.z = Model(ModelID).Skeliton(n).Origin.z
        Cx = TempMorph(Target).Origin.x
        Cy = TempMorph(Target).Origin.y
        Cz = TempMorph(Target).Origin.z
        sAngle1 = TempMorph(Target).Angle.x
        sAngle2 = TempMorph(Target).Angle.y
        sAngle3 = TempMorph(Target).Angle.z
        If World(Unit).Morph(Target).MoveFirst = False Then
            x = TempMorph(Target).Origin.x + Model(ModelID).Skeliton(n).Origin.x - Model(ModelID).Skeliton(Target).Origin.x + World(Unit).Morph(n).Origin.x
            y = TempMorph(Target).Origin.y + Model(ModelID).Skeliton(n).Origin.y - Model(ModelID).Skeliton(Target).Origin.y + World(Unit).Morph(n).Origin.y
            z = TempMorph(Target).Origin.z + Model(ModelID).Skeliton(n).Origin.z - Model(ModelID).Skeliton(Target).Origin.z + World(Unit).Morph(n).Origin.z
        Else
            x = TempMorph(Target).Origin.x + Model(ModelID).Skeliton(n).Origin.x - Model(ModelID).Skeliton(Target).Origin.x
            y = TempMorph(Target).Origin.y + Model(ModelID).Skeliton(n).Origin.y - Model(ModelID).Skeliton(Target).Origin.y
            z = TempMorph(Target).Origin.z + Model(ModelID).Skeliton(n).Origin.z - Model(ModelID).Skeliton(Target).Origin.z
        End If
        TempMorph(n).Angle.x = World(Unit).Morph(n).Angle.x + sAngle1
        TempMorph(n).Angle.y = World(Unit).Morph(n).Angle.y + sAngle2
        TempMorph(n).Angle.z = World(Unit).Morph(n).Angle.z + sAngle3
        sRotate sAngle1, sAngle2, sAngle3, x, y, z, Cx, Cy, Cz
        If World(Unit).Morph(Target).MoveFirst = False Then
            TempMorph(n).Origin.x = Rotates.x
            TempMorph(n).Origin.y = Rotates.y
            TempMorph(n).Origin.z = Rotates.z
        Else
            TempMorph(n).Origin.x = Rotates.x + World(Unit).Morph(n).Origin.x
            TempMorph(n).Origin.y = Rotates.y + World(Unit).Morph(n).Origin.y
            TempMorph(n).Origin.z = Rotates.z + World(Unit).Morph(n).Origin.z
            TempMorph(n).Angle.x = 0
            TempMorph(n).Angle.y = 0
            TempMorph(n).Angle.z = 0
        End If
    Next n
End Sub

Private Sub DrawObject(Unit)
    Dim Ner(12, 2) As Integer, n As Integer, m As Integer, s1 As Integer, x1 As Integer, y1 As Integer, z1 As Integer
    Dim xx1 As Integer, yy1 As Integer, xx2 As Integer, yy2 As Integer, X2 As Integer, Y2 As Integer, Z2 As Integer
    On Error GoTo Yikes
    For n = 1 To Model(ModelID).FaceCount
        For m = 1 To Model(ModelID).EdgeCount(n)
            s1 = Model(ModelID).Face(n, m)
            x1 = TempVert(s1).x:  y1 = TempVert(s1).y: z1 = TempVert(s1).z
            Ner(m, 1) = Xf + Int(x1 * (Zeye / (Zeye - z1)))
            Ner(m, 2) = Yf + Int(y1 * (Zeye / (Zeye - z1)))
        Next m
        If ((Ner(1, 2) - Ner(3, 2)) * (Ner(2, 1) - Ner(1, 1)) - (Ner(1, 1) - Ner(3, 1)) * (Ner(2, 2) - Ner(1, 2))) < 0 Then
            For m = 1 To Model(ModelID).EdgeCount(n) - 1
                xx1 = Ner(m, 1): yy1 = Ner(m, 2)
                xx2 = Ner(m + 1, 1): yy2 = Ner(m + 1, 2)
                FrmMain.View.Line (xx1, yy1)-(xx2, yy2)
            Next m
            xx1 = Ner(m, 1): yy1 = Ner(m, 2)
            xx2 = Ner(1, 1): yy2 = Ner(1, 2)
            FrmMain.View.Line (xx1, yy1)-(xx2, yy2)
        End If
    Next n
    
    
    For n = 1 To Model(ModelID).SkelitonCount
        RotatePoint Unit, n
        World(Unit).MNode(n).x = Rotates.x
        World(Unit).MNode(n).y = Rotates.y
        World(Unit).MNode(n).z = Rotates.z
    Next n
    
    If Model(ModelID).ForceSkeliton = True Then
        For n = 2 To Model(ModelID).SkelitonCount
            x1 = World(Unit).MNode(n).x
            y1 = World(Unit).MNode(n).y
            z1 = World(Unit).MNode(n).z

            X2 = World(Unit).MNode(Model(ModelID).Skeliton(n).Target).x
            Y2 = World(Unit).MNode(Model(ModelID).Skeliton(n).Target).y
            Z2 = World(Unit).MNode(Model(ModelID).Skeliton(n).Target).z
            xx1 = Xf + Int(x1 * (Zeye / (Zeye - z1)))
            yy1 = Yf + Int(y1 * (Zeye / (Zeye - z1)))
            xx2 = Xf + Int(X2 * (Zeye / (Zeye - Z2)))
            yy2 = Yf + Int(Y2 * (Zeye / (Zeye - Z2)))
            FrmMain.View.Line (xx1, yy1)-(xx2, yy2), vbRed
        Next n
    End If
Yikes:
End Sub



Private Sub RotatePoint(Unit, n)
    Dim Oangle1 As Integer, OAngle2 As Integer, Oangle3 As Integer, nn As Integer
    Dim WAngle1 As Integer, WAngle2 As Integer, WAngle3 As Integer, Target As Byte
    Dim x As Integer, y As Integer, z As Integer, XRotated As Integer, YRotated As Integer, ZRotated As Integer
    Oangle1 = World(Unit).Angle.x Mod 360
    OAngle2 = World(Unit).Angle.y Mod 360
    Oangle3 = World(Unit).Angle.z Mod 360
    WAngle1 = Camara.Angle.x Mod 360
    WAngle2 = Camara.Angle.y Mod 360
    WAngle3 = Camara.Angle.z Mod 360
    WAngle2 = 360 - WAngle2
    x = TempMorph(n).Origin.x
    y = TempMorph(n).Origin.y
    z = TempMorph(n).Origin.z
    XRotated = COSine(OAngle2) * x - SINe(OAngle2) * z
    YRotated = y
    ZRotated = SINe(OAngle2) * x + COSine(OAngle2) * z
    x = XRotated: y = YRotated: z = ZRotated
    XRotated = x
    YRotated = COSine(Oangle1) * y - SINe(Oangle1) * z
    ZRotated = SINe(Oangle1) * y + COSine(Oangle1) * z
    x = XRotated: y = YRotated: z = ZRotated
    XRotated = (COSine(Oangle3) * x - SINe(Oangle3) * y)
    YRotated = (SINe(Oangle3) * x + COSine(Oangle3) * y)
    ZRotated = z
    x = XRotated: y = YRotated: z = ZRotated
    
        World(Unit).Node(n).x = XRotated
        World(Unit).Node(n).y = YRotated
        World(Unit).Node(n).z = ZRotated
    
    
    XRotated = COSine(WAngle2) * x - SINe(WAngle2) * z
    YRotated = y
    ZRotated = SINe(WAngle2) * x + COSine(WAngle2) * z
    x = XRotated: y = YRotated: z = ZRotated
    XRotated = x
    YRotated = COSine(WAngle1) * y - SINe(WAngle1) * z
    ZRotated = SINe(WAngle1) * y + COSine(WAngle1) * z
    x = XRotated: y = YRotated: z = ZRotated
    XRotated = COSine(WAngle3) * x - SINe(WAngle3) * y
    YRotated = SINe(WAngle3) * x + COSine(WAngle3) * y
    ZRotated = z
    Rotates.x = XRotated + World(Unit).Rotated.x
    Rotates.y = YRotated - World(Unit).Rotated.y
    Rotates.z = ZRotated - World(Unit).Rotated.z
End Sub

Private Sub Rotate(Unit)
    Dim Oangle1 As Integer, OAngle2 As Integer, Oangle3 As Integer, nn As Integer
    Dim WAngle1 As Integer, WAngle2 As Integer, WAngle3 As Integer, Target As Byte
    Dim Mangle1 As Integer, Mangle2 As Integer, Mangle3 As Integer
    Dim x As Integer, y As Integer, z As Integer, XRotated As Integer, YRotated As Integer, ZRotated As Integer
    Oangle1 = World(Unit).Angle.x Mod 360
    OAngle2 = World(Unit).Angle.y Mod 360
    Oangle3 = World(Unit).Angle.z Mod 360
    WAngle1 = Camara.Angle.x Mod 360
    WAngle2 = Camara.Angle.y Mod 360
    WAngle3 = Camara.Angle.z Mod 360
    WAngle2 = 360 - WAngle2
    If Model(ModelID).SkelitonCount > 0 Then MorphSkeliton Unit
    For nn = 1 To Model(ModelID).VertexCount
        Target = Model(ModelID).Vertex(nn).Target
        Mangle1 = TempMorph(Target).Angle.x Mod 360
        Mangle2 = TempMorph(Target).Angle.y Mod 360
        Mangle3 = TempMorph(Target).Angle.z Mod 360
        x = Model(ModelID).Vertex(nn).x - Model(ModelID).Skeliton(Target).Origin.x
        y = Model(ModelID).Vertex(nn).y - Model(ModelID).Skeliton(Target).Origin.y
        z = Model(ModelID).Vertex(nn).z - Model(ModelID).Skeliton(Target).Origin.z
        
        
        XRotated = (COSine(Mangle3) * x - SINe(Mangle3) * y)
        YRotated = (SINe(Mangle3) * x + COSine(Mangle3) * y)
        ZRotated = z
        
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = x
        YRotated = COSine(Mangle1) * y - SINe(Mangle1) * z
        ZRotated = SINe(Mangle1) * y + COSine(Mangle1) * z
        
        
        x = XRotated: y = YRotated: z = ZRotated
        
        If World(Unit).Morph(Target).MoveFirst = False Then
            XRotated = (COSine(Mangle2) * x - SINe(Mangle2) * z) + TempMorph(Target).Origin.x
            YRotated = y + TempMorph(Target).Origin.y
            ZRotated = (SINe(Mangle2) * x + COSine(Mangle2) * z) + TempMorph(Target).Origin.z
        Else
            XRotated = COSine(Mangle2) * x - SINe(Mangle2) * z
            YRotated = y
            ZRotated = SINe(Mangle2) * x + COSine(Mangle2) * z
        End If
        
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = COSine(Oangle3) * x - SINe(Oangle3) * y
        YRotated = SINe(Oangle3) * x + COSine(Oangle3) * y
        ZRotated = z
        
        
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = x
        YRotated = COSine(Oangle1) * y - SINe(Oangle1) * z
        ZRotated = SINe(Oangle1) * y + COSine(Oangle1) * z
        
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = COSine(OAngle2) * x - SINe(OAngle2) * z
        YRotated = y
        ZRotated = SINe(OAngle2) * x + COSine(OAngle2) * z
        
        
        If World(Unit).Morph(Target).MoveFirst = True Then
            x = XRotated + TempMorph(Target).Origin.x
            y = YRotated + TempMorph(Target).Origin.y
            z = ZRotated + TempMorph(Target).Origin.z
        Else
             x = XRotated: y = YRotated: z = ZRotated
        End If
        
        
        
        XRotated = COSine(WAngle2) * x - SINe(WAngle2) * z
        YRotated = y
        ZRotated = SINe(WAngle2) * x + COSine(WAngle2) * z
        x = XRotated: y = YRotated: z = ZRotated
        
        XRotated = x
        YRotated = COSine(WAngle1) * y - SINe(WAngle1) * z
        ZRotated = SINe(WAngle1) * y + COSine(WAngle1) * z
        x = XRotated: y = YRotated: z = ZRotated
        
        XRotated = COSine(WAngle3) * x - SINe(WAngle3) * y
        YRotated = SINe(WAngle3) * x + COSine(WAngle3) * y
        ZRotated = z
        
        
        TempVert(nn).x = XRotated + World(Unit).Rotated.x
        TempVert(nn).y = YRotated - World(Unit).Rotated.y
        TempVert(nn).z = ZRotated - World(Unit).Rotated.z
    Next nn
End Sub

Private Sub sRotate(tAngle1, tAngle2, tAngle3, x, y, z, Cx, Cy, Cz)
    Dim XRotated As Integer, YRotated As Integer, ZRotated As Integer
    tAngle1 = (tAngle1 Mod 360):    tAngle2 = (tAngle2 Mod 360):    tAngle3 = (tAngle3 Mod 360)
    If tAngle1 < 0 Then tAngle1 = tAngle1 + 360
    If tAngle2 < 0 Then tAngle2 = tAngle2 + 360
    If tAngle3 < 0 Then tAngle3 = tAngle3 + 360
    x = x - Cx:    y = y - Cy:    z = z - Cz
    XRotated = COSine(tAngle3) * x - SINe(tAngle3) * y
    YRotated = SINe(tAngle3) * x + COSine(tAngle3) * y:    ZRotated = z
    
    x = XRotated:    y = YRotated:    z = ZRotated
    YRotated = COSine(tAngle1) * y - SINe(tAngle1) * z
    ZRotated = SINe(tAngle1) * y + COSine(tAngle1) * z: XRotated = x
    
    x = XRotated:    y = YRotated:    z = ZRotated:    XRotated = x
    XRotated = COSine(tAngle2) * x - SINe(tAngle2) * z:    YRotated = y
    ZRotated = SINe(tAngle2) * x + COSine(tAngle2) * z
    
    
    Rotates.x = XRotated + Cx:    Rotates.y = YRotated + Cy:    Rotates.z = ZRotated + Cz
End Sub

Private Sub RotateWorld()
    Dim WAngle1 As Integer, WAngle2 As Integer, WAngle3 As Integer, EachUNIT As Integer
    Dim x As Integer, y As Integer, z As Integer, XRotated As Integer, YRotated As Integer, ZRotated As Integer
    WAngle1 = Camara.Angle.x Mod 360
    WAngle2 = Camara.Angle.y Mod 360
    WAngle3 = Camara.Angle.z Mod 360
    For EachUNIT = 1 To WorldCount
        x = World(EachUNIT).Origin.x + Camara.Origin.x
        y = World(EachUNIT).Origin.y - Camara.Origin.y
        z = World(EachUNIT).Origin.z + Camara.Origin.z
        XRotated = COSine(WAngle2) * x - SINe(WAngle2) * z
        YRotated = y
        ZRotated = SINe(WAngle2) * x + COSine(WAngle2) * z
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = x
        YRotated = COSine(WAngle1) * y - SINe(WAngle1) * z
        ZRotated = SINe(WAngle1) * y + COSine(WAngle1) * z
        x = XRotated: y = YRotated: z = ZRotated
        XRotated = COSine(WAngle3) * x - SINe(WAngle3) * y
        YRotated = SINe(WAngle3) * x + COSine(WAngle3) * y
        ZRotated = z
        World(EachUNIT).Rotated.x = XRotated
        World(EachUNIT).Rotated.y = YRotated
        World(EachUNIT).Rotated.z = ZRotated
    Next EachUNIT
End Sub
