Attribute VB_Name = "Main"
Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long
Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long



Public Const Zeye = 800
Public WorldCount
Public Const PI = 3.14159265358979

Type ColourDis
    Red As Byte
    Green As Byte
    Blue As Byte
End Type

Type Coord
    x As Integer
    y As Integer
    z As Integer
    Target As Integer
End Type

Type SkelitonDis
    Origin As Coord
    Target As Integer
    Name As String
    Huuh As String
End Type

Type WeaponDis
    Name As String
    Type As String
    Joint As Integer
    Vangle As Integer
    HAngle As Integer
End Type

Type Objects
    VertexCount As Integer
    Vertex() As Coord
    FaceCount As Integer
    Face() As Integer
    EdgeCount() As Integer
    SkelitonCount As Integer
    Skeliton() As SkelitonDis
    WeaponCount As Byte
    Weapon() As WeaponDis
    ForceSkeliton As Boolean
End Type

Type Morph
    Origin As Coord
    Angle As Coord
    Scale As Coord
    MoveFirst As Boolean
End Type


Type WorldDis
    Morph(30) As Morph
    Node(30) As Coord
    MNode(30) As Coord
    Used As Boolean
    Origin As Coord
    Rotated As Coord
    Angle As Coord
    Timer As Integer
    ModelID As Byte
    UnitID As Byte
    GibSpeed As Coord
    Frame As Single
    Size As Integer
    Colour As Byte
End Type

Type CamaraDis
    CamaraMode As Byte
    Timer As Integer
    Object As Integer
    Origin As Coord
    Speed As Byte
    Angle As Coord
    TargetA As Coord
    TargetO As Coord
    AddA As Coord
    AddO As Coord
End Type

Type KeyBoardDis
    Forward As Boolean
    Backward As Boolean
    Left As Boolean
    Right As Boolean
    Fire As Boolean
    Num1 As Boolean
    Num2 As Boolean
    Num3 As Boolean
    Num4 As Boolean
    Num5 As Boolean
    Num6 As Boolean
    Num7 As Boolean
    Num8 As Boolean
    Num9 As Boolean
    Num0 As Boolean
    Escape As Boolean
    Q As Boolean
    A As Boolean
    W As Boolean
    S As Boolean
    E As Boolean
    D As Boolean
    R As Boolean
    F As Boolean
End Type

Public TempMorph() As Morph
Public Keyboard As KeyBoardDis
Public Camara As CamaraDis
Public ModelID As Byte
Public World() As WorldDis
Public SINe(-361 To 361) As Double
Public COSine(-361 To 361) As Double
Public Model() As Objects
Public TempVert(500) As Coord

Public Function GetNewFloat()
    For n = 1 To WorldCount
        If World(n).Used = False Then GetNewFloat = n: Exit Function
    Next n
    WorldCount = WorldCount + 1
    ReDim Preserve World(WorldCount) As WorldDis
    GetNewFloat = WorldCount
End Function



Public Sub LoadData()

    Randomize Timer

    Open App.Path & "\Buildings.txt" For Input As #1
    Do While EOF(1) = False
        Input #1, Text
        If Left(Text, 2) = "mb" Then
            Load FrmMain.bc(FrmMain.bc.Count + 1)
            FrmMain.bc(FrmMain.bc.Count).Caption = Mid(Text, 3, 99)
            FrmMain.bc(FrmMain.bc.Count).Visible = True
            FrmMain.bc(FrmMain.bc.Count).Enabled = True
            FrmMain.bc(0).Visible = False
        Else
            Load FrmMain.bm(FrmMain.bm.Count + 1)
            FrmMain.bm(FrmMain.bm.Count).Caption = Mid(Text, 3, 99)
            FrmMain.bm(FrmMain.bm.Count).Visible = True
            FrmMain.bm(FrmMain.bm.Count).Enabled = True
            FrmMain.bm(0).Visible = False
        End If
    Loop
    Close

    Camara.CamaraMode = 1
    Camara.Origin.x = 0
    Camara.Origin.y = 150
    Camara.Origin.z = 0
    Camara.Angle.x = 0
    Camara.Angle.y = 0
    Camara.Angle.z = 0
    WorldCount = 20
    ReDim Preserve World(WorldCount) As WorldDis

    World(1).Origin.x = 0
    World(1).Origin.y = 0 '<<  If you wanna be a plane, change this to 500 (so you're in da sky)
    World(1).Origin.z = 0
    World(1).Angle.y = 0
    World(1).ModelID = 6  '<<<  If you wanna be a plane, change this to 11
    World(1).UnitID = 17
    World(1).Used = True
    
    
    World(2).Origin.x = -250
    World(2).Origin.y = 0
    World(2).Origin.z = 100
    World(2).ModelID = 5
    World(2).UnitID = 1
    World(2).Used = True
    
    World(3).Origin.x = 250
    World(3).Origin.y = 0
    World(3).Origin.z = 100
    World(3).ModelID = 5
    World(3).UnitID = 1
    World(3).Used = True

    For n = 4 To 10
        World(n).Origin.y = 0
        World(n).Origin.x = (Rnd * 400) - 200
        World(n).Origin.z = 200 + (Rnd * 900)
        World(n).ModelID = 10
        World(n).UnitID = 8
        World(n).Used = True
        World(n).Frame = Rnd * 20
    Next n
    TotalModels = 11
    
    ReDim Model(TotalModels) As Objects
    
    For ModelID = 1 To TotalModels
        If ModelID = 1 Then FileName = "\Shot.dat"
        If ModelID = 2 Then FileName = "\House.dat"
        If ModelID = 3 Then FileName = "\Scrap1.dat"
        If ModelID = 4 Then FileName = "\Scrap2.dat"
        If ModelID = 5 Then FileName = "\Mill2.dat"
        If ModelID = 6 Then FileName = "\Tank.dat"
        If ModelID = 7 Then FileName = "\Crane.dat"
        If ModelID = 8 Then FileName = "\Forklift.dat"
        If ModelID = 9 Then FileName = "\Buldozer.dat"
        If ModelID = 10 Then FileName = "\Man.dat": Model(ModelID).ForceSkeliton = True
        If ModelID = 11 Then FileName = "\Plane.dat"
        Open App.Path & FileName For Input As #1
            Input #1, Model(ModelID).VertexCount
            ReDim Model(ModelID).Vertex(Model(ModelID).VertexCount) As Coord
            Input #1, Model(ModelID).FaceCount
            ReDim Model(ModelID).Face(Model(ModelID).FaceCount, 11) As Integer
            ReDim Model(ModelID).EdgeCount(Model(ModelID).FaceCount) As Integer
            For n = 1 To Model(ModelID).VertexCount
                Input #1, Model(ModelID).Vertex(n).x
                Input #1, Model(ModelID).Vertex(n).y
                Input #1, Model(ModelID).Vertex(n).z
                Input #1, Model(ModelID).Vertex(n).Target
            Next n
            For n = 1 To Model(ModelID).FaceCount
                Input #1, FaceEdge
                Model(ModelID).EdgeCount(n) = FaceEdge
                For m = 1 To FaceEdge
                    Input #1, x: Model(ModelID).Face(n, m) = x + 1
                Next m
            Next n
            Input #1, Skel
            If Skel > BigSkel Then BigSkel = Skel
            Model(ModelID).SkelitonCount = Skel
            ReDim Model(ModelID).Skeliton(Skel) As SkelitonDis
            For n = 1 To Skel
                Input #1, x
                Input #1, y
                Input #1, z
                Input #1, WeKnow
                Model(ModelID).Skeliton(WeKnow).Origin.x = x
                Model(ModelID).Skeliton(WeKnow).Origin.y = y
                Model(ModelID).Skeliton(WeKnow).Origin.z = z
                Input #1, Model(ModelID).Skeliton(WeKnow).Target
                Input #1, Model(ModelID).Skeliton(WeKnow).Name
                Input #1, Model(ModelID).Skeliton(WeKnow).Huuh
            Next n
            Input #1, gun
            Model(ModelID).WeaponCount = gun
            ReDim Model(ModelID).Weapon(gun) As WeaponDis
            For n = 1 To gun
                Input #1, Model(ModelID).Weapon(n).Joint
                Input #1, Model(ModelID).Weapon(n).Name
                Input #1, Model(ModelID).Weapon(n).Type
                Input #1, Model(ModelID).Weapon(n).Vangle
                Input #1, Model(ModelID).Weapon(n).HAngle
            Next n
        Close
    Next ModelID
    ReDim TempMorph(BigSkel) As Morph
End Sub

Public Sub Make_Lookup()
    For i = -361 To 361: SINe(i) = Sin(i / 180 * PI): COSine(i) = Cos(i / 180 * PI):   Next
End Sub







